--*****************************************************************
-- exportSectionMeshEXT_gmax
--   Modified : 2009.08.15
--   Original Script : By Deniska
--   URL: http://www.gtaforums.com/index.php?showtopic=269717
--*****************************************************************

-----text2bin.txt-----
--it supports these commands: 
--b = 1 byte integer
--w = 2 byte integer
--i = 4 byte integer
--
--f = 4 byte float single
--d = 8 byte float double
--
--c = char, number should tell how many bytes to write, 
--	text must be in one line, if number of letters in string 
--	is less than number you give it will pad it with zeroes. 
--	use '~' for spaces, program wants the string to be in 
--	single line without spaces. 
--
--all non-floating point numbers are signed, if you need 
--unsigned ones (invalid integer value errors) tell me.
--------------------

fn writeStringZero str N = (
  local i, len
  format ("c " + N as string +" " + str + "\n")
) -- fn writeStringZero

----------------------------------------------------------------------------------------------------------------

fn getID n maxn = (mod (n-1) maxn) as integer + 1

----------------------------------------------------------------------------------------------------------------
fn getTextura m n = (
  local mat, res = #()
  
  if isKindOf m Multimaterial then mat = m[n]
  else mat = m
  
  if isKindof mat Standard then (
    if mat.diffuseMap!=undefined do res[1] = getFileNameFile mat.diffuseMap.fileName
    if mat.opacityMap!=undefined do res[2] = getFileNameFile mat.opacityMap.fileName
    ) -- if isKindof mat Standard
  else(
    if isKindOf mat Gta_Mtl do (
      if mat.ColorMap!=undefined do res[1] = getFileNameFile mat.ColorMap.fileName
      if mat.AlphaMap!=undefined do res[2] = getFileNameFile mat.AlphaMap.fileName
      ) --  if isKindOf mat Gta_Mtl 
    ) -- else
  res
  ) -- fn getTextura
----------------------------------------------------------------------------------------------------------------


fn writeMeshExtSection obj par1 par2 par3 par4= (
  local i, j, k
  local NumMV = #(), MFace = #(), freeMap = #(), VC = #(), MV = #(), V = #(), FS = #(), MAT = #(), MATtmp = #()
  local NumF = obj.NumFaces, Textur = #(), Textura = #(), TexNum = 0, MaxID, ObjMat, aaa, ID, NumObj = 0

  if not meshop.getMapSupport obj 0 do meshop.setMapSupport obj 0 true
  NumMV[1] = meshop.getNumMapVerts obj 0
  NumMV[2] = meshop.getNumMapVerts obj 1
  ObjMat = obj.material
  for i = 1 to NumF do MATtmp[(getFaceMatID obj i)] = 1
  MaxID = MATtmp.count
  if MaxID == 0 do MaxID = 1

  for i = 1 to NumF do (
    MFace[1] = meshOp.getMapFace obj 0 i
    MFace[2] = meshOp.getMapFace obj 1 i
    ff = getFace obj i
    FS[i] = [MFace[2][1]-1, MFace[2][2]-1, MFace[2][3]-1]
    MAT[i] = getId (getFaceMatID obj i) MaxID
    if Textur[MAT[i]]==undefined do (
      aaa = getTextura obj.material MAT[i]
      if aaa[1]!=undefined then textur[MAT[i]]=aaa[1] else textur[MAT[i]] = ""
      if aaa[2]!=undefined then textura[MAT[i]]=aaa[2] else textura[MAT[i]] = ""
      ) -- if Textur[MAT[i]]==undefined

    for j = 1 to 3 do (
      if freeMap[MFace[2][j]]==undefined do (
        col = getVertColor obj MFace[1][j]
        VC[MFace[2][j]] = (color (col.r as integer) (col.g as integer) (col.b as integer) (col.a as integer))
        MV[MFace[2][j]] = meshOp.getMapVert obj 1 MFace[2][j]
        V[MFace[2][j]] = getVert obj ff[j]
        ) -- if freeMap[MFace[2][j]]==undefined
      ) -- for j
    ) -- for i

  vychet = #(); for i = 1 to MaxID do vychet[i]=1

  for i = 1 to MaxID do (
    if textur[i]==undefined then (
      for j = i to MaxID do vychet[j] += 1
      ) -- if
    else (
      NumObj+=1
      ) -- else
    ) -- for i

if 1!=1 do ( -- ================================================================================


for i = 1 to MV.count do (
  format ("MV[" + i as string +"]\t: " + MV[i] as string + "\n")
) -- for i

for i = 1 to obj.numfaces do (
  format ("FS[" + i as string +"]\t: " + FS[i] as string + "\n")
) -- for i

) -- if 1!=1 ================================================================================






  format ("b 4 " + par1 as string + " " + par2 as string + " " + par3 as string + " " + par4 as string + "\n")
  format ("i 3 1 " + V.count as string + " 0\n")
  format ("i 4 0 0 " + NumF as string + " 0\n")
  format ("i 4 0 " + NumObj as string + " 0 0\n")
  format ("i 2 0 0\n")

  for i = 1 to V.count do (  -------------------------------------------  VERTS
    if V[i]!=undefined then (
        format ("f 3 " + V[i].x as string + " " + V[i].y as string + " " + V[i].z as string + "\n")
      ) -- if
    else (
      format ("f 3 0.0 0.0 0.0\n")
      ) -- else
    ) -- for i

  for i = 1 to MV.count do ( ------------------------------------------- UV COORDS
    if MV[i]!=undefined then (
--      format ("f 2 " + MV[i].x as string + " " + MV[i].y as string + "\n")
      format ("f 2 " + (MV[i].x) as string + " " + (1 - MV[i].y) as string + "\n")
      ) -- if
    else (
      format ("f 2 0.0 0.0\n")
      ) -- else
    ) -- for i

  for i = 1 to VC.count do ( --------------------------------------------- V COLORS
    if VC[i]!=undefined then (
      format ("b 4 " + (VC[i].r as integer) as string + " " + (VC[i].g as integer) as string + " " + (VC[i].b as integer) as string + " " + (VC[i].a as integer) as string + "\n")
      ) -- if
    else (
      format ("b 4 0 0 0 0\n")
      ) -- else
    ) -- for i

  for i = 1 to NumF do ( ------------------------------------------------ FACES
    format ("w 3 " + (FS[i][1] as integer) as string + " " + (FS[i][2] as integer) as string + " " + (FS[i][3] as integer) as string + "\n")
  ) -- for i

  for i = 1 to NumF do ( ----------------------------------------------- MAT ID
    format ("w 1 " + (MAT[i] - vychet[MAT[i]]) as string + "\n")
  ) -- for i


  for i = 1 to MaxID do ( ---------------------------------------- TEXTURE
    if textur[i]!=undefined do(
      if textur[i]!="" then writeStringZero textur[i] 32
      else format ("i 8 0 0 0 0 0 0 0 0\n")
    ) -- if textur[i]!=undefined
  ) -- for i

  for i = 1 to MaxID do ( ----------------------------------------- TEXTURE A
    if textur[i]!=undefined do(
      if textura[i]!="" then writeStringZero textura[i] 32
      else format ("i 8 0 0 0 0 0 0 0 0\n")
      ) -- if textur[i]!=undefined
    ) -- for i

  for i = 1 to NumObj do format ("f 3 1.0 1.0 1.0\n")
  
  )-- fn writeMeshExtSection


----------------------------------------------------------------------------------------------------------------

rollout MeshExt_rol "" width:190 height:105
(
	label lbl2 "unk1" pos:[7,47] width:31 height:20
	spinner u1 "" pos:[39,47] width:50 height:16 range:[0,255,100] type:#integer
	label lbl3 "unk2" pos:[96,47] width:31 height:20
	spinner u2 "" pos:[128,47] width:50 height:16 range:[0,255,100] type:#integer
	label lbl4 "unk3" pos:[8,72] width:31 height:20
	spinner u3 "" pos:[40,72] width:50 height:16 range:[0,255,100] type:#integer
	label lbl5 "unk4" pos:[97,72] width:31 height:20
	spinner u4 "" pos:[129,72] width:50 height:16 range:[0,255,100] type:#integer
	button exp "export section" pos:[9,6] width:168 height:30
	checkbox gtamaxON "Use GTAmax.exe" pos:[9,97] checked:true width:200

  on exp pressed do (
    s = selection
    if s.count != 1 then messageBox "select just 1 object"
    else (
      fname = getSaveFileName caption:"export section 0x253F2FD" \
                          types:"binary|*.bin" --"D:\\SA_MOD\\BRAKABLE\\sec_test1.bin"
      if fname != undefined do (				
        format "\n"             --Don't remove this, it solve some win98 user problem
        clearlistener()
        if gtamaxON.checked == true then 	format "<snoopstart file=%>\n" fname
        else format "<!--path=\"%\"-->\n" fname
        
        obj = copy s[1]
        ConvertToMesh obj
        writeMeshExtSection obj u1.value u2.value u3.value u4.value
        delete obj
        
        if gtamaxON.checked == true then 	format "</snoopend>\n"
        format "//"             --Don't remove this, it solve some win98 user problem
        
        ) -- if fname
      ) -- if s.count
    ) -- on exp pressed
  
  ) -- rollout

try (closeRolloutFloater MeshExt_flo) catch ()
--MeshExt_flo = NewRolloutFloater "0x253F2FD export" 210 130 100 120
MeshExt_flo = NewRolloutFloater "0x253F2FD export" 210 180 100 120
addRollout MeshExt_rol MeshExt_flo